<?php

/**
 * Class blockfourdempro
 */
class blockfourdempro extends Module {
	const SYNCH_ALL_CUSTOMERS = 0;
	const SYNCH_SPECIFIC_CUSTOMER = 1;
	/**
	 * ****************************************************************************
	 * Funzione __construct()
	 * Contiene tutte le informazioni del modulo visualizzate nel backend (nome, versione, descrizione).
	 *
	 * E' possibile selezionare il TAB all'interno del quale visualizzare il modulo
	 * *****************************************************************************
	 */
	function __construct() {
		$this->name = "blockfourdempro";
		$this->tab = 'front_office_features'; // Products
		$this->version = '3.1.0';
		$this->need_instance = 0;
		$this->displayName = $this->l ( '4Dem for Prestashop 1.7 PRO' );
		$this->description = $this->l ( '4Dem Newsletter integration for Prestashop e-commerce. PRO Version.' );
		$this->author = "Tembo s.r.l.";
		$this->bootstrap = true;
        $this->ps_versions_compliancy = array(
            'min' => '1.7',
            'max' => '1.8'
        );
		parent::__construct ();
		if(Module::isInstalled("blockfourdempro")){
			require_once "api4marketing.php";
			if(Configuration::get ( '4DEM_CONSOLE_URL',"" )!="" &&  Configuration::get ( '4DEM_API_KEY',"" )!="")
				$this->api4marketingObject = new api4marketingPro ( Configuration::get ( '4DEM_CONSOLE_URL' ), Configuration::get ( '4DEM_API_KEY' ) );
			else
				$this->api4marketingObject = null;

		}

	}

    /**
     * Metodo di installazione
     *
     * @return bool
     */
	function install() {

		$sql = "
			CREATE TABLE `"._DB_PREFIX_."4dem_bridge` (
			  `id_user` int(11) unsigned DEFAULT NULL,
			  `id4dem` int(11) unsigned DEFAULT NULL,
			  `email` varchar(128) DEFAULT '',
			  `error` text
			) ENGINE=InnoDB DEFAULT CHARSET=latin1;";
		$create = Db::getInstance ()->execute ( $sql );

		$sql = "
			CREATE TABLE `"._DB_PREFIX_."4dem_last_sync` (
			  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
			  `type` varchar(50) DEFAULT NULL,
			  `date` datetime DEFAULT NULL,
			  `id_batch` int(11) DEFAULT NULL,
			  `completed` tinyint(1) DEFAULT NULL,
			  `error` int(11) DEFAULT NULL,
			  `tot` int(11) DEFAULT NULL,
			  `group` int(11) DEFAULT NULL,
			  PRIMARY KEY (`id`)
			) ENGINE=InnoDB DEFAULT CHARSET=latin1;";
		$create &= Db::getInstance ()->execute ( $sql );

		$sql = "
			ALTER TABLE `"._DB_PREFIX_."cart`
			ADD COLUMN `4dem_source` varchar(20) DEFAULT NULL,
			ADD COLUMN `4dem_source_id` int(11) DEFAULT NULL";
		$create &= Db::getInstance ()->execute ( $sql );


		Configuration::updateValue ( '4DEM_CONSOLE_URL', "https://api.4dem.it" );
		$tab = new Tab();
		$tab->active = 1;
		$tab->class_name = 'AdminBlockfourdempro';
		$tab->name = array();
		foreach (Language::getLanguages(true) as $lang)
			$tab->name[$lang['id_lang']] = '4Dem Ajax Controller';
		$tab->id_parent = -1;
		$tab->module = $this->name;

		if (parent::install () == false
			||	$tab->add() == false
			|| 	!$create
			||  $this->registerHook ( 'actionObjectCustomerUpdateAfter' ) == false
			||  $this->registerHook ( 'actionObjectCustomerDeleteAfter' ) == false
			||  $this->registerHook ( 'actionObjectGroupUpdateAfter' ) == false
			||  $this->registerHook ( 'actionObjectGroupAddAfter' ) == false
			||  $this->registerHook ( 'actionObjectGroupDeleteAfter' ) == false
			||  $this->registerHook ( 'actionObjectCartUpdateAfter' ) == false
			||  $this->registerHook ( 'displayHeader' ) == false)
			return false;
		Configuration::updateValue ('4DEM_API_VERSION',2 );
		Configuration::updateValue ('4DEM_INVALID_ORDER_STATE',"");
		Configuration::updateValue ('4DEM_ORDER_STATES',"");
		return true;
	}

    /**
     * Metodo di disinstallazione
     *
     * @return mixed
     */
	public function uninstall()
	{

        $this->api4marketingObject = new api4marketingPro ( Configuration::get ( '4DEM_CONSOLE_URL' ), Configuration::get ( '4DEM_API_KEY' ) );
		$this->api4marketingObject->archiveList(Configuration::get("4DEM_SELECTED_LIST_ID"));

		$sql ="DROP TABLE `"._DB_PREFIX_."4dem_bridge`";
		try {
			Db::getInstance ()->execute ( $sql );
		} catch (Exception $e) {
			$this->_errors[] = $e->getMessage();
		}
		$sql ="DROP TABLE `"._DB_PREFIX_."4dem_last_sync`";
		try {
			Db::getInstance ()->execute ( $sql );
		} catch (Exception $e) {
			$this->_errors[] = $e->getMessage();
		}
		$sql ="DROP TABLE `"._DB_PREFIX_."4dem_bridge_carts`";
		try {
			Db::getInstance ()->execute ( $sql );
		} catch (Exception $e) {
			$this->_errors[] = $e->getMessage();
		}
		$sql ="ALTER TABLE `"._DB_PREFIX_."cart` DROP COLUMN `4dem_source`,DROP COLUMN `4dem_source_id`";
		try {
			Db::getInstance ()->execute ( $sql );
		} catch (Exception $e) {
			$this->_errors[] = $e->getMessage();
		}
		$tab = new Tab(Tab::getIdFromClassName("AdminBlockfourdempro"));
		$tab->delete();
		Configuration::deleteByName('4DEM_API_VERSION');
		Configuration::deleteByName('4DEM_CONSOLE_URL');
		Configuration::deleteByName('4DEM_LAST_SYNC_CONTACTS');
		Configuration::deleteByName('4DEM_API_KEY');
		Configuration::deleteByName('4DEM_CUSTOM_FIELDS');
		Configuration::deleteByName('4DEM_SELECTED_LIST_ID');
		Configuration::deleteByName('4DEM_WEBSERVER_UNSUBSCRIBE_ID');
		Configuration::deleteByName('4DEM_LAST_BATCH');
		Configuration::deleteByName('4DEM_CUSTOM_FIELDS_WAITING');
		Configuration::deleteByName('4DEM_STORE_ID');
		Configuration::deleteByName('4DEM_STORE_ATTRIBUTES');
		Configuration::deleteByName('4DEM_PRODUCTS_SYNC_GROUP');
		Configuration::deleteByName('4DEM_PRODUCT_SYNC_GROUP');
		Configuration::deleteByName('4DEM_MAIL_ERRORS');
		Configuration::deleteByName('4DEM_LAST_SYNC_PRODUCTS');
		Configuration::deleteByName('4DEM_LAST_SYNC_CARTS');
		Configuration::deleteByName('4DEM_CONTACT_SYNC_GROUP');
		Configuration::deleteByName('4DEM_CART_SYNC_GROUP');
		Configuration::deleteByName('4DEM_ATTRIBUTES_MAP');
		Configuration::deleteByName('4DEM_INVALID_ORDER_STATE');
		Configuration::deleteByName('4DEM_ORDER_STATES');

        Configuration::deleteByName('4DEM_LAST_CMD_CONTACTS');
        Configuration::deleteByName('4DEM_LAST_CMD_PRODUCTS');
        Configuration::deleteByName('4DEM_LAST_CMD_CART');
        Configuration::deleteByName('4DEM_SELECTED_LIST_NAME');
        Configuration::deleteByName('4DEM_CONTACT_LAST_BATCH');

		return parent::uninstall();
	}

    /**
     * Pubblicazione dei warnings
     *
     * @param $string Messaggio da mostrare
     * @return mixed
     */
	private function warning($string){
		if(Tools::version_compare(_PS_VERSION_,"1.6.1","<"))
			$output = $this->adminDisplayWarning($string);
		else
			$output = $this->displayWarning($string);
		return $output ;

	}

    /**
     * Inclusione file js
     *
     * @param $params
     */
	public function hookDisplayHeader($params)
	{

        $this->context->controller->registerJavascript(
            $this->name . '-4dem-js',
            Configuration::get ( '4DEM_CONSOLE_URL' )=="" ? "https://api.4dem.it/" : Configuration::get ( '4DEM_CONSOLE_URL' ).'/c4rt/js/ect.min.js',
            array('server' => 'remote')
        );
	}

    /**
     * Funzione getContent()
     * Prima funzione che viene caricata dal gestore dei moduli.
     * Tools:getValue --> Legge il valore di un parametro in get o post
     * Tools:isSubmit --> Verifica se il form è stato submittato (salvataggio parametri)
     * A sua volta richiama la displayForm() che contiene le direttive dell'interfaccia di configurazione
     *
     * Prestashop config variables
     * 4DEM_API_KEY							-- Api Key console
     * 4DEM_PASSWORD						-- Password console
     * 4DEM_CONSOLE_URL						-- Url console
     * 4DEM_CUSTOM_FIELDS					-- Mappatura Custom Fields per sapere quali ignorare
     * 4DEM_MAIL_ERRORS						-- Eventuali fallimenti di import mail
     * 4DEM_LAST_SYNC_CONTACTS				-- Data ultima sincronizzazione
     *
     * @return string
     */
	public function getContent() {

		$output="";
		//$this->api4marketingObject->createWebServiceUnsubscribe(Tools::getCurrentUrlProtocolPrefix().Tools::getHttpHost().$this->_path."/s2s/unsubscribe.php","gabriele@tembo.it");
		if(Shop::isFeatureActive() && Context::getContext()->shop->getContext() != Shop::CONTEXT_SHOP){
			$output.=$this->warning($this->l('This module works only for a single shop. Select a shop to be able to configure it.'));
		}

		// String variable per output errori
		if (Tools::isSubmit ( 'submitUpdate' )) {
			// VARIABILE PER GESTIONE ERRORE INPUT
			$mod = false;

			// DEM_API_KEY VALUE
			$dem_api_key = strval ( Tools::getValue ( '4DEM_API_KEY' ) );
			if ($dem_api_key && !empty ( $dem_api_key ) && Validate::isGenericName ( $dem_api_key ) && $dem_api_key!=Configuration::get("4DEM_API_KEY")){
				$mod = $mod || true;
				//Configuration::deleteByName('4DEM_CUSTOM_FIELDS');
				Configuration::deleteByName('4DEM_SELECTED_LIST_ID');

				Configuration::updateValue ( '4DEM_API_KEY', $dem_api_key );

			}

			// 4DEM 4DEM_CONSOLE_URL
			$dem_console_url = strval ( Tools::getValue ( '4DEM_CONSOLE_URL' ) );
			if ($dem_console_url && !empty ( $dem_console_url ) && Validate::isGenericName ( $dem_console_url ) && $dem_console_url!=Configuration::get("4DEM_CONSOLE_URL")){
				$mod = $mod || true;
				//Configuration::deleteByName('4DEM_CUSTOM_FIELDS');
				Configuration::deleteByName('4DEM_SELECTED_LIST_ID');

				Configuration::updateValue ( '4DEM_CONSOLE_URL', $dem_console_url );

			}
			$this->api4marketingObject = new api4marketingPro ( Configuration::get ( '4DEM_CONSOLE_URL' ), Configuration::get ( '4DEM_API_KEY' ) );
			if (!isset($this->api4marketingObject) || $this->api4marketingObject==null || ! $this->api4marketingObject->getStatus ()) {
				$output .= $this->displayError ( $this->l('The inserted API KEY or CONSOLE URL are not correct'));
			} else if($mod){
				$output .= $this->displayConfirmation ( $this->l('Successfully connected to API service'));
			}
			//header('Location: '.$_SERVER['REQUEST_URI']);
			//$output .= $this->displayConfirmation ( $this->l ( 'Settings updated' ) );
		}

		if (Tools::isSubmit ( 'createNewList' )) {

			$ret = $this->api4marketingObject->createList();
			if($ret !== true) {
				$output .= $this->displayError($ret);
				return $output . $this->displayForm ();
			}

            $ret = $this->api4marketingObject->checkList(Configuration::get ( '4DEM_SELECTED_LIST_ID' ));
            if($ret !== true) {
                $output .= $this->displayError($this->l('List not found or incompatible with this shop'));
                return $output . $this->displayForm ();
            }

			$ret = $this->api4marketingObject->createCustomFields(Configuration::get ( '4DEM_SELECTED_LIST_ID' ),$this->createFieds(),Tools::getCurrentUrlProtocolPrefix().Tools::getHttpHost().$this->_path."/s2s/customFields.php");
			if($ret !== true) {
				$output .= $this->displayError($this->l('Custom fields creation Error'));
				return $output . $this->displayForm ();
			}

			$ret = $this->api4marketingObject->createWebServiceUnsubscribe(Tools::getCurrentUrlProtocolPrefix().Tools::getHttpHost().$this->_path."/s2s/unsubscribe.php");
			if($ret!== false){
				Configuration::updateValue ( '4DEM_WEBSERVER_UNSUBSCRIBE_ID', $ret );
			} else {
				$output .= $this->displayError($this->l('An error occured during the creation of Unsubscription Webservice'));
				return $output . $this->displayForm ();
			}
			$output .= $this->displayConfirmation ( $this->l ( 'New list created' ) );
		}

        if (Tools::isSubmit ( 'SelectNewList' )) {

            $listId = Tools::getValue('ListToFind');

            $ret = $this->api4marketingObject->checkList($listId);
            if($ret !== true) {
                $output .= $this->displayError($this->l('List not found or incompatible with this shop'));
                return $output . $this->displayForm ();
            }

            $ret = $this->api4marketingObject->updateList($listId);
            if($ret !== true) {
                $output .= $this->displayError($this->l('Failed to upload list!'));
                return $output . $this->displayForm ();
            }

            $ret = $this->api4marketingObject->checkCustomFields(Configuration::get ( '4DEM_SELECTED_LIST_ID' ), $this->createFieds());
            if($ret == 0) {
                $ret = $this->api4marketingObject->createCustomFields(Configuration::get ( '4DEM_SELECTED_LIST_ID' ),$this->createFieds(),Tools::getCurrentUrlProtocolPrefix().Tools::getHttpHost().$this->_path."/s2s/customFields.php");
                if($ret !== true) {
                    $output .= $this->displayError($this->l('Custom fields creation Error'));
                    return $output . $this->displayForm ();
                }
            }
            else if($ret !== true) {
                Configuration::updateValue( '4DEM_SELECTED_LIST_ID', null);
                Configuration::updateValue( '4DEM_SELECTED_LIST_NAME', null);
                $output .= $this->displayError($this->l('Custom fields do not match!'));
                return $output . $this->displayForm ();
            }

            $ret = $this->api4marketingObject->createWebServiceUnsubscribe(Tools::getCurrentUrlProtocolPrefix().Tools::getHttpHost().$this->_path."/s2s/unsubscribe.php");
            if($ret!== false){
                Configuration::updateValue ( '4DEM_WEBSERVER_UNSUBSCRIBE_ID', $ret );
            } else {
                $output .= $this->displayError($this->l('An error occured during the creation of Unsubscription Webservice'));
                return $output . $this->displayForm ();
            }
            $output .= $this->displayConfirmation ( $this->l ( 'New list added' ) );
        }

        if (Tools::isSubmit ( 'deleteStore' )) {
            if (Configuration::hasKey('4DEM_STORE_ID') && (is_numeric(Configuration::get ( '4DEM_STORE_ID' )))) {
                $ret = $this->api4marketingObject->deleteStore(Configuration::get ( '4DEM_STORE_ID' ));
                if ($ret !== true) {
                    $output .= $this->displayError($this->l('An error occured during deleting store. Please retry.'));
                    return $output . $this->displayForm ();
                } else {
                    Configuration::deleteByName('4DEM_STORE_ID');
                    $output .= $this->displayConfirmation ( $this->l ( 'Store deleted' ) );
                }
            }
//            $output .= $this->displayConfirmation ( $this->l ( 'Store deleted' ) );
        }

        
		return $output . $this->displayForm ();
	}

    /**
     * Crea un array di corrispondenza per i campi personalizzati
     *
     * @return array
     */
	public function createFieds(){
		$fields = array();

		// Campi Single Line

		$field["name"] = "Nome";
		$field["type"] = "Single line";
		$field["val"] = "NULL";
		$fields["name"] = $field;

		$field["name"] = "Cognome";
		$fields["surname"] = $field;

		$field["name"] = "Sesso";
		$fields["sex"] = $field;

		$field["name"] = "Lingua";
		$fields["language"] = $field;


		$field["name"] = "Guest";
		$fields["is_guest"] = $field;

		$field["name"] = "Paese";
		$fields["country"] = $field;

		$field["name"] = "Provincia";
		$fields["province"] = $field;

		$field["name"] = "Citta";
		$fields["city"] = $field;

		$field["name"] = "Sorgente";
		$fields["source"] = $field;


		//Campi Data

		$field["name"] = "Data registrazione al sito";
		$field["type"] = "Date field";
		$fields["reg_date"] = $field;

		$field["name"] = "Data di nascita";
		$fields["birth_date"] = $field;

		$field["name"] = "Data iscrizione Newsletter";
		$fields["news_date"] = $field;

		$field["name"] = "Ultima connessione";
		$fields["last_conn"] = $field;

		$field["name"] = "Ultimo Ordine";
		$fields["last_order"] = $field;

		$field["name"] = "Gruppo";
		$field["type"] = "Checkboxes";
		$field["options"] = array();
		foreach(Group::getGroups(Context::getContext()->language->id) as $key => $gruppo){
			$opt = array();
			$opt["label"] = $gruppo["name"];
			$opt["val"] = $gruppo["id_group"];
			$field["options"][] = $opt;
		}
		$fields["group"] = $field;
		return $fields;
	}

    /**
     * Visualizzazione del pannello di amministrazione del modulo
     *
     * @return mixed
     */
	public function displayForm() {
		$connStatus="";
		$this->context->controller->addJS ( $this->_path . '/js/blockfourdempro.js', 'all' );
		if (!isset($this->api4marketingObject) || $this->api4marketingObject==null || ! $this->api4marketingObject->getStatus ()) {
			$connStatus .= "Offline";
		} else {
			$connStatus .= "Online";
		}
		if(!isset($this->_html))
			$this->_html="";
		$api_url = Configuration::get ( '4DEM_CONSOLE_URL' )=="" ? "https://api.4dem.it/" : Configuration::get ( '4DEM_CONSOLE_URL' );
		$psCompatibleList = false;
		$custom_fields_not_ready = false;
		$logged=true;

		$store=null;
		// Test connection
		if (isset($this->api4marketingObject) && $this->api4marketingObject!=null && $this->api4marketingObject->getStatus ()) {
			// Get lists array from console

            if (!is_null(Configuration::get ( '4DEM_SELECTED_LIST_ID'))) {
                $psCompatibleList = Configuration::get ( '4DEM_SELECTED_LIST_NAME');
            }

//			$dem_console_lists = $this->api4marketingObject->getLists();
//
//			if ($dem_console_lists == false)
//				$dem_console_lists = array();
//			foreach ($dem_console_lists as $dem_console_listobject) {
//				$integration = $dem_console_listobject->integration;
//				if ($integration) {
//					if ($integration->active == true && $integration->domain == Context::getContext()->shop->domain && $integration->shopid == Context::getContext()->shop->id && $integration->module == "prestashop") {
//						$psCompatibleList = $dem_console_listobject->name;
//						$customFields = $this->api4marketingObject->getCustomFields($dem_console_listobject->id);
//
//						$fields = $this->createFieds();
//						$json = array();
//						$actual_fields = Configuration::get("4DEM_CUSTOM_FIELDS", "");
//						if ($actual_fields != "") {
//							$actual_fields = json_decode($actual_fields, true);
//							$all_false = true;
//							$all_numeric = true;
//							foreach ($actual_fields as $name => $campo) {
//								if ($name != "cellphone") {
//									$all_false = $actual_fields && $campo["id"] === false;
//									$all_numeric = $all_numeric && is_numeric($campo["id"]);
//								}
//							}
//							if ($all_false && Configuration::get("4DEM_CUSTOM_FIELDS_WAITING") == 1) {
//								$custom_fields_not_ready = true;
//								$this->warning($this->l('Custom Fields are not processed yet, wait some time and then try to refresh page, if everything went well you should find Custom Fields option in the section below.'));
//							} else if (!$all_numeric) {
//								$this->displayError($this->l('There is an error with the custom fields.'));
//								$this->warning($this->l(' We suggest to delete the List from 4Dem Panel and recreate it with this module. Remember not to modify the Custom Fields form 4Dem Panel once the list is created.'));
//
//							} else if (count($customFields) >= count($fields)) {
//								foreach ($customFields as $customField) {
//									//ppp($customField);
//									foreach ($fields as $key => $field) {
//										if ($customField->name == $field["name"]) {
//											$json[$key]["ignore"] = false;
//											$json[$key]["id"] = $customField->id;
//											$json[$key]["name"] = $field["name"];
//											break;
//										}
//									}
//								}
//								if (count($json) != count($fields)) {
//									$this->displayError($this->l('There is an error with the custom fields.'));
//									$this->warning($this->l(' We suggest to delete the List from 4Dem Panel and recreate it with this module. Remember not to modify the Custom Fields form 4Dem Panel once the list is created.'));
//								}
//								if (!Configuration::get('4DEM_CUSTOM_FIELDS') || Configuration::get('4DEM_CUSTOM_FIELDS') == json_encode(array())) {
//									$json["cellphone"]["ignore"] = false;
//									$json["cellphone"]["name"] = "N° Cellulare";
//									Configuration::updateValue('4DEM_CUSTOM_FIELDS', json_encode($json));
//								}
//							} else {
//								$this->displayError($this->l('There is an error with the custom fields.'));
//								$this->warning($this->l(' We suggest to delete the List from 4Dem Panel and recreate it with this module. Remember not to modify the Custom Fields form 4Dem Panel once the list is created.'));
//
//							}
//						} else {
//							$this->displayError($this->l('There is an error with the custom fields.'));
//							$this->warning($this->l(' We suggest to delete the List from 4Dem Panel and recreate it with this module. Remember not to modify the Custom Fields form 4Dem Panel once the list is created.'));
//						}
//
//						if (!Configuration::get('4DEM_SELECTED_LIST_ID')) {
//
////							Configuration::updateValue('4DEM_SELECTED_LIST_ID', $dem_console_listobject->id);
//						}
//						if (isset($integration->last_sync_date)) {
//							Configuration::updateValue('4DEM_LAST_SYNC_CONTACTS', date("Y-m-d H:i:s", strtotime($integration->last_sync_date)));
//						}
//					}
//				}
//
//			}
			$dem_console_stores = $this->api4marketingObject->getStores();
			foreach ($dem_console_stores as $dem_console_storesobject) {
				if($dem_console_storesobject->shop_id == Context::getContext()->shop->id && $dem_console_storesobject->recipient_id == Configuration::get("4DEM_SELECTED_LIST_ID")){
					if(Configuration::get("4DEM_STORE_ID")!=$dem_console_storesobject->id){
						Configuration::updateValue("4DEM_STORE_ID",$dem_console_storesobject->id);
					}
					$store_attributes = $this->api4marketingObject->getStoreAttribute($dem_console_storesobject->id);
					if($store_attributes){
						$json_attr = array("attributes" => array(),"features"=>array());
						foreach ($store_attributes as $attr){
							$id = explode("-",$attr->attribute_id);
							$type = $id[0] == "f" ? "features" : "attributes";
							$json_attr[$type][$id[1]]["id_4dem"] = $attr->id;
							$json_attr[$type][$id[1]]["name"] = $attr->name;
						}
						Configuration::updateValue("4DEM_ATTRIBUTES_MAP",json_encode($json_attr));
					}
					$store = $dem_console_storesobject;
				}
			}
		}else{
			$logged = false;
		}
//		if($psCompatibleList == false) {
//			Configuration::updateValue('4DEM_SELECTED_LIST_ID', "");
//			Configuration::updateValue('CUSTOM_FIELDS', "");
//			Configuration::updateValue('LAST_SYNC', "");
//			Configuration::updateValue('STORE_ID', "");
//		}
		//die("-".$custom_fields_not_ready."-".$psCompatibleList ."-". Configuration::get ( '4DEM_SELECTED_LIST_ID' ) ."-". Configuration::get ( '4DEM_SELECTED_LIST_ID' )."-");
		$sql="SELECT c.email,b.error FROM "._DB_PREFIX_."4dem_bridge as b JOIN "._DB_PREFIX_."customer as c ON b.id_user = c.id_customer WHERE error <> null OR error <> ''";
		$this->smarty->assign(array(
			'path' => $this->_path,
			'API_KEY' => Tools::getValue ( '4DEM_API_KEY', Configuration::get ( '4DEM_API_KEY' )),
			'REQUEST_URI' => Tools::safeOutput ( $_SERVER ['REQUEST_URI'] ),
			'CONSOLE_URL' => Tools::getValue ( '4DEM_CONSOLE_URL', $api_url ),
			'SELECTED_LIST_ID' => Configuration::get ( '4DEM_SELECTED_LIST_ID' ),
			'CUSTOM_FIELDS' => Configuration::get("4DEM_CUSTOM_FIELDS",""),
			'LAST_SYNC_CONTACTS' => Configuration::get('4DEM_LAST_SYNC_CONTACTS'),
			'LAST_SYNC_PRODUCTS' => Configuration::get('4DEM_LAST_SYNC_PRODUCTS'),
			'LAST_SYNC_CARTS' => Configuration::get('4DEM_LAST_SYNC_CARTS'),
			'STORE_ID' => Configuration::get('4DEM_STORE_ID'),
			'ATTRIBUTES_MAP' => json_decode(Configuration::get('4DEM_ATTRIBUTES_MAP'),true),
			'api4marketingObject' => $this->api4marketingObject,
			'context' => Context::getContext(),
			'logged' => $logged,
			'connStatus' => $connStatus,
			// GENERAL SETTINGS
			'psCompatibleList' => $psCompatibleList,
			'sync_errors' => Db::getInstance ()->executeS( $sql ),
			'total_subscribers' => 0, //$this->getSubscribedCustomers(),
			'custom_fields_not_ready' => $custom_fields_not_ready,
			'custom_field_ready' => !$custom_fields_not_ready && $psCompatibleList && Configuration::get ( '4DEM_SELECTED_LIST_ID' ) &&  Configuration::get ( '4DEM_SELECTED_LIST_ID' ) != 0,
			// STORE SETTINGS
			'store_present' => false,
			'store' => $store,
			'ajax_controller_url' => Context::getContext()->link->getAdminLink("AdminBlockfourdempro", true),
			// CURL SETTINGS
			'CONTACT_SYNC_GROUP' => Configuration::get("4DEM_CONTACT_SYNC_GROUP") === false ? 0 : Configuration::get("4DEM_CONTACT_SYNC_GROUP"),
			'PRODUCT_SYNC_GROUP' => Configuration::get("4DEM_PRODUCT_SYNC_GROUP") === false ? 0 : Configuration::get("4DEM_PRODUCT_SYNC_GROUP"),
			'CART_SYNC_GROUP' => Configuration::get("4DEM_CART_SYNC_GROUP") === false ? 0 : Configuration::get("4DEM_CART_SYNC_GROUP"),
			'order_states' => OrderStateCore::getOrderStates(Context::getContext()->language->id),
			'selected_order_states' => (Configuration::get("4DEM_ORDER_STATES") != "" ? json_decode(Configuration::get("4DEM_ORDER_STATES"),true) : []),
			'invalid_order_state' => (Configuration::get("4DEM_INVALID_ORDER_STATE") != "" ? json_decode(Configuration::get("4DEM_INVALID_ORDER_STATE"),true) : []),
			'products_in_store' => $this->getProductCount(),
			'carts_in_store' => $this->getCartsCount(),
			'curl_url_contacts' => __DIR__.'/cron/cron.php contacts',
			'curl_url_products' => __DIR__.'/cron/cron.php products',
			'curl_url_carts' => __DIR__.'/cron/cron.php carts'
		));

        Configuration::updateValue("4DEM_SMARTY",json_encode($this->smarty));
		$this->context->controller->addCSS(($this->_path).'/css/style.css', 'all');
		return $this->display(__FILE__, $this->name.'.tpl');;
	}

    /**
     * Ritorna il numero degli iscritti alla newsletter
     *
     * @return mixed
     */
	public function getSubscribedCustomers(){

		$sql = 'SELECT COUNT(*)
				FROM `'._DB_PREFIX_.'customer`
				WHERE active = 1 AND deleted = 0
				ORDER BY `email` ';
		return Db::getInstance(_PS_USE_SQL_SLAVE_)->getValue($sql);
	}

	/********* Hooks ************/

	public function hookActionObjectCustomerDeleteAfter($params) {
		if($params["object"]->newsletter == 1) {
			$sql = "SELECT id4dem FROM "._DB_PREFIX_."4dem_bridge WHERE email = '".$params["object"]->email."'";
			$id = Db::getInstance ()->getValue( $sql );
			if ($id) {
				$this->api4marketingObject->unsubscribe(Configuration::get('4DEM_SELECTED_LIST_ID'), $params["object"]->email);
			}
		}
	}

    /**
     * @param $params
     */
    public function hookActionObjectGroupDeleteAfter($params) {
		$customFields = json_decode(Configuration::get('4DEM_CUSTOM_FIELDS'));
		if(count($customFields)!=0){
			$groupCustom = $customFields->group->id;
			$fields = $this->api4marketingObject->getCustomFields(Configuration::get("4DEM_SELECTED_LIST_ID"));
			$field["name"] = "Gruppo";
			$field["type"] = "Checkboxes";
			$field["options"] = array();
			foreach(Group::getGroups(Context::getContext()->language->id) as $key => $gruppo){
				$opt = array();
				$opt["label"] = $gruppo["name"];
				$opt["val"] = $gruppo["id_group"];
				$field["options"][] = $opt;
			}
			$this->api4marketingObject->updateCustomField(Configuration::get("4DEM_SELECTED_LIST_ID"),$field,$groupCustom);
		}
	}
	public function hookActionObjectGroupUpdateAfter($params) {
		$customFields = json_decode(Configuration::get('4DEM_CUSTOM_FIELDS'));
		if(count($customFields)!=0){
			$groupCustom = $customFields->group->id;
			$fields = $this->api4marketingObject->getCustomFields(Configuration::get("4DEM_SELECTED_LIST_ID"));
			$field["name"] = "Gruppo";
			$field["type"] = "Checkboxes";
			$field["options"] = array();
			foreach(Group::getGroups(Context::getContext()->language->id) as $key => $gruppo){
				$opt = array();
				$opt["label"] = $gruppo["name"];
				$opt["val"] = $gruppo["id_group"];
				$field["options"][] = $opt;
			}
			$this->api4marketingObject->updateCustomField(Configuration::get("4DEM_SELECTED_LIST_ID"),$field,$groupCustom);
		}
	}
	public function hookActionObjectGroupAddAfter($params) {

		$customFields = json_decode(Configuration::get('4DEM_CUSTOM_FIELDS'));
		if(count($customFields)!=0){
			$groupCustom = $customFields->group->id;
			$fields = $this->api4marketingObject->getCustomFields(Configuration::get("4DEM_SELECTED_LIST_ID"));
			$field["name"] = "Gruppo";
			$field["type"] = "Checkboxes";
			$field["options"] = array();
			foreach(Group::getGroups(Context::getContext()->language->id) as $key => $gruppo){
				$opt = array();
				$opt["label"] = $gruppo["name"];
				$opt["val"] = $gruppo["id_group"];
				$field["options"][] = $opt;
			}
			$this->api4marketingObject->updateCustomField(Configuration::get("4DEM_SELECTED_LIST_ID"),$field,$groupCustom);
		}

	}
	public function hookActionObjectCustomerUpdateAfter($params) {
		if($params["object"]->newsletter == 0) {
			$sql = "SELECT id4dem FROM "._DB_PREFIX_."4dem_bridge WHERE email = '".$params["object"]->email."'";
			$id = Db::getInstance ()->getValue( $sql );
			if ($id) {
				$this->api4marketingObject->unsubscribe(Configuration::get('4DEM_SELECTED_LIST_ID'), $id);
			}
		}

	}
    public function hookActionObjectCartUpdateAfter($params){
        if(isset($_COOKIE["ectDem"])){
            $cookie = json_decode($_COOKIE["ectDem"],true);
            $sql = "UPDATE "._DB_PREFIX_."cart SET 4dem_source = '".$cookie["mode"]."', 4dem_source_id = ".$cookie["id"]. " WHERE id_cart = ".$params["object"]->id;
            Db::getInstance()->execute($sql);
        }
    }

    /**
     * Switch per le operazioni del cron
     *
     * @param $type Tipo di oggetto sul quale effettuare la sincronizzazione
     * @return array|bool
     */
	public function CronSync($type){
		$ret=false;
		switch($type) {
			case "contacts": $ret= $this->SynchAllData (self::SYNCH_ALL_CUSTOMERS,false,"cron",0);
				Configuration::updateValue( '4DEM_LAST_SYNC_CONTACTS',date("Y-m-d H:i:s"));
				Configuration::updateValue( '4DEM_CONTACT_SYNC_GROUP',0);
				break;
			case "products": $ret= $this->SynchProducts (false,"cron",0);
				Configuration::updateValue( '4DEM_LAST_SYNC_PRODUCTS',date("Y-m-d H:i:s"));
				Configuration::updateValue( '4DEM_PRODUCT_SYNC_GROUP',0);
				break;
			case "carts":
				$ret = $this->SynchCarts(false,"cron",0);
				Configuration::updateValue( '4DEM_LAST_SYNC_CARTS',date("Y-m-d H:i:s"));
				Configuration::updateValue( '4DEM_CART_SYNC_GROUP',0);
				break;
		}
		return $ret;
	}

    /**
     * Sincronizzazione contatti
     *
     * @param $synchMode
     * @param bool $all         Per sincronizzare tutti i contatti
     * @param $type             Tipo di chiamata (ajax, cron)
     * @param $limit            Limite di record da estrarre
     * @return array|bool
     */
	public function SynchAllData($synchMode, $all = false,$type,$limit) {

	    $dateSync = Configuration::get('4DEM_LAST_SYNC_CONTACTS');
		$dateSync = date("Y-m-d H:i:s", strtotime($dateSync)-60);
		if($all)
			$dateSync = 0;
		/**
		 * ****************************************************************************
		 * Funzione synch($allData = false, $singleCustomerID = -1)
		 * Sincronizza tutti i dati di Prestashop con la console
		 *
		 * *****************************************************************************
		 */
		/*
		 * SELECT CHE INDIVDUA 1. Tutti gli utenti della tabella customers che hanno fatto almeno un ordine 2. La data dell'ultimo ordine effettuato 3. Tutti gli utenti che, seppur registrati, non hanno mai fatto un ordine
		 */
		// Se Fallisce l'inizializzazione, esce di brutto
		if (! $this->api4marketingObject->getStatus ()) {
			return false;
		}

		$group_id = Configuration::get("4DEM_CONTACT_SYNC_GROUP",0);
		if (Configuration::get ( '4DEM_SELECTED_LIST_ID' ) && (($synchMode == self::SYNCH_ALL_CUSTOMERS) || ($synchMode == self::SYNCH_SPECIFIC_CUSTOMER ))) {

			$sql =
				(($dateSync != NULL) ? "SELECT * FROM (" : "") . "
			SELECT " .
				(($dateSync != NULL) ? " customersData.date_upd as upd_cust,"._DB_PREFIX_."address.date_upd as upd_address," : "") . "
			customersData.id_customer,
			GROUP_CONCAT(DISTINCT " . _DB_PREFIX_ . "customer_group.id_group) as gruppi,
			" . _DB_PREFIX_ . "lang.iso_code AS lingua,
			" . _DB_PREFIX_ . "state.iso_code AS provincia,
			" . _DB_PREFIX_ . "address.city,
			" . _DB_PREFIX_ . "country_lang.name AS paese,
			customersData.is_guest, 
			IF (customersData.id_gender = 1 , \"M\" , IF (customersData.id_gender = 2 , \"F\" , \"NS\")) AS gender ,
			customersData.firstname,
			customersData.lastname,
			customersData.email,
			( SELECT c.date_add FROM " . _DB_PREFIX_ . "guest g LEFT JOIN " . _DB_PREFIX_ . "connections c ON c.id_guest = g.id_guest WHERE g.id_customer = customersData.id_customer ORDER BY c.date_add DESC LIMIT 1 ) as ultima_connessione ,
			customersData.newsletter_date_add,
			customersData.newsletter,
			" . _DB_PREFIX_ . "address.phone_mobile,
			customersData.birthday,
			customersData.date_add AS registrazione,
			customersOrders.lastOrderPlaced
		FROM " . _DB_PREFIX_ . "customer customersData
			LEFT JOIN " . _DB_PREFIX_ . "lang ON customersData.id_lang = " . _DB_PREFIX_ . "lang.id_lang
			LEFT JOIN " . _DB_PREFIX_ . "address ON customersData.id_customer = " . _DB_PREFIX_ . "address.id_customer
			LEFT JOIN " . _DB_PREFIX_ . "country_lang ON " . _DB_PREFIX_ . "address.id_country = " . _DB_PREFIX_ . "country_lang.id_country AND customersData.id_lang = " . _DB_PREFIX_ . "country_lang.id_lang
			LEFT JOIN " . _DB_PREFIX_ . "state ON " . _DB_PREFIX_ . "address.id_state = " . _DB_PREFIX_ . "state.id_state
			LEFT JOIN " . _DB_PREFIX_ . "customer_group ON " . _DB_PREFIX_ . "customer_group.id_customer = customersData.id_customer
			LEFT JOIN (
			SELECT id_customer, date(MAX(date_add)) AS lastOrderPlaced
				FROM " . _DB_PREFIX_ . "orders
			GROUP BY id_customer ) customersOrders ON customersData.id_customer = customersOrders.id_customer

		WHERE   customersData.active = 1
				AND customersData.deleted = 0
		GROUP BY customersData.id_customer
		" . (($dateSync != NULL) ? ') AS tab  WHERE upd_cust > "' . $dateSync . '" OR ultima_connessione > "' . $dateSync . '" OR lastOrderPlaced > "' . $dateSync . '" OR upd_address > "' . $dateSync . '"' : "") . "
		ORDER BY id_customer
            ".($type=="ajax" ? 'LIMIT '.$limit.', 1000' : "");

			/**
			 * **********************************************************************************
			 * ESECUZIONE DEL CODICE CHE
			 * 1 TENTA DI EFFETTUARE L'INSERIMENTO
			 * 2 SE NON VA A BUON FINE (ESISTE GIA') ESEGUE UN UPDATE
			 * **********************************************************************************
			 */

			// Salvo l'ultima query eseguita
            Configuration::updateValue('4DEM_LAST_CMD_CONTACTS', $sql);

			$err = array();
			$result_data = Db::getInstance()->executeS($sql);
			if($group_id == 0) {
				$group_id = strtotime(date("Y-m-d H:i:s"));
				Configuration::updateValue("4DEM_CONTACT_SYNC_GROUP", $group_id);
			}

			if ($result_data && count($result_data)>0) {
				$operations = array();
				foreach ($result_data as $key => $row) {
					// Use custom fields data
					$subscribeFields = array();
					$subscribeValues = array();
					$fields = json_decode(Configuration::get("4DEM_CUSTOM_FIELDS"), true);

					if (!$fields["source"]["ignore"]) {
                        $subscribeFields [] = $fields["source"]["id"];
                        $subscribeValues [] = "prestashop";
                    }

					if (!$fields["name"]["ignore"]) {
						$subscribeFields [] = $fields["name"]["id"];
						$subscribeValues [] = ($row ['firstname'] != null ? $row ['firstname'] : "-");
					}
					if (!$fields["surname"]["ignore"]) {
						$subscribeFields [] = $fields["surname"]["id"];
						$subscribeValues [] = ($row ['lastname'] != null ? $row ['lastname'] : "-");
					}
					if (!$fields["sex"]["ignore"]) {
						$subscribeFields [] = $fields["sex"]["id"];
						$subscribeValues [] = ($row ['gender'] != null ? $row ['gender'] : "-");
					}
					if (!$fields["language"]["ignore"]) {
						$subscribeFields [] = $fields["language"]["id"];
						$subscribeValues [] = ($row ['lingua'] != null ? $row ['lingua'] : "-");
					}
					if (!$fields["is_guest"]["ignore"]) {
						$subscribeFields [] = $fields["is_guest"]["id"];
						$subscribeValues [] = ($row ['is_guest'] != null ? $row ['is_guest'] : "-");
					}
					if (!$fields["country"]["ignore"]) {
						$subscribeFields [] = $fields["country"]["id"];
						$subscribeValues [] = ($row ['paese'] != null ? $row ['paese'] : "-");
					}
					if (!$fields["province"]["ignore"]) {
						$subscribeFields [] = $fields["province"]["id"];
						$subscribeValues [] = ($row ['provincia'] != null ? $row ['provincia'] : "-");
					}
					if (!$fields["city"]["ignore"]) {
						$subscribeFields [] = $fields["city"]["id"];
						$subscribeValues [] = ($row ['city'] != null ? $row ['city'] : "-");
					}
					if (!$fields["cellphone"]["ignore"]) {
						$mobile = $row ['phone_mobile'];
						$mobile = str_replace(' ', '', $mobile);
						$mobile = str_replace('.', '', $mobile);
						$mobile = str_replace('-', '', $mobile);
						if (preg_match('/^\+[1-9]{1}[0-9]{3,14}$/', $mobile)==0) {
							
							if (strlen($mobile) == 9) {
								$mobile = "+39" . $mobile; 
							}
							else if (strlen($mobile) == 10) {
								$mobile = "+39" . $mobile;
							}
							else if (strlen($mobile) == 12) {
								$mobile = "+" . $mobile;
							}
							else if (strlen($mobile) == 14) {
								$mobile = preg_replace('^(00)39[0-9]*$', '+', $mobile); 
							} else {
								$mobile = "";
							}

							if (preg_match('/^\+393[0-9]{8,9}$/', $mobile)==0) {  //is italian ?
								$mobile = "";
							 }
						}
						
						$mobile = urlencode($mobile);
					}
					if (!$fields["reg_date"]["ignore"]) {
						$subscribeFields [] = $fields["reg_date"]["id"];
						$subscribeValues [] = ($row ['registrazione'] != null ? $row ['registrazione'] : "0000-00-00");
					}
					if (!$fields["birth_date"]["ignore"]) {
						$subscribeFields [] = $fields["birth_date"]["id"];
						$subscribeValues [] = ($row ['birthday'] != null ? $row ['birthday'] : "0000-00-00");
					}
					if (!$fields["news_date"]["ignore"]) {
						$subscribeFields [] = $fields["news_date"]["id"];
						$subscribeValues [] = ($row ['newsletter_date_add'] != null ? $row ['newsletter_date_add'] : "0000-00-00");
					}
					if (!$fields["last_conn"]["ignore"]) {
						$subscribeFields [] = $fields["last_conn"]["id"];
						$subscribeValues [] = ($row ['ultima_connessione'] != null ? $row ['ultima_connessione'] : "0000-00-00");
					}
					if (!$fields["last_order"]["ignore"]) {
						$subscribeFields [] = $fields["last_order"]["id"];
						$subscribeValues [] = ($row ['lastOrderPlaced'] != null ? $row ['lastOrderPlaced'] : "0000-00-00");
					}

					if (!$fields["group"]["ignore"]) {
						$gruppi = explode(",", $row["gruppi"]);
						$subscribeFields [] = $fields["group"]["id"];
						$val = "";
						foreach ($gruppi as $gruppo) {
							$val .= $gruppo . "||||";
						}
						$subscribeValues [] = rtrim($val, "||||");

					}

					$command["command"] = "Subscriber.Store";
					$command["custom_id"] = $row["id_customer"];
					$command["body"] = $this->generateCustomerData($row ['email'], $mobile, $subscribeFields, $subscribeValues, $row['newsletter']);
					$operations[] = $command;
				}
                Configuration::updateValue("4DEM_CONTACT_LAST_BATCH", $group_id);
				$ret = $this->api4marketingObject->massiveImport(Tools::getCurrentUrlProtocolPrefix() . Tools::getHttpHost() . $this->_path . "/s2s/callback.php", $operations);
				if (is_numeric($ret)) {
					$sql = "INSERT INTO " . _DB_PREFIX_ . "4dem_last_sync (`type`,`date`,`id_batch`,`completed`,`error`,`group`,`tot`) VALUES ('contacts','" . date("Y-m-d H:i:s") . "',$ret,0,0,$group_id,".($key+1).")";
					Db::getInstance()->execute($sql);
					$limit += 1000;
					return (array("group_id"=>$group_id,"status"=>"waiting","limit"=>$limit, "done" => 0, "tot" => 0));
				}else {
					$err = ($ret);
					return (array("err" => $err, "status" => "error", "limit" => $limit, "done" => 0, "tot" => 0));
				}
			}
			if (count($err) == 0) {
				$this->importEmailsubscribers();
				Configuration::updateValue('4DEM_LAST_SYNC_CONTACTS', date("Y-m-d H:i:s"));
				$this->api4marketingObject->updList(Configuration::get("4DEM_SELECTED_LIST_ID"));
				return (array("group_id"=>$group_id,"status"=>"completed", "done" => 0, "tot" => 0));
			} else {
//				return $err;
                return (array("group_id"=>$group_id,"status"=>"error", "done" => 0, "tot" => 0));
			}
		}
	}
	
    /**
     * Sincronizzazione prodotti
     *
     * @param bool $all
     * @param $type
     * @param $limit
     * @return array|bool
     * @throws PrestaShopDatabaseException
     * @throws PrestaShopException
     */
	public function SynchProducts($all = false,$type,$limit) {

		$dateSync = Configuration::get('4DEM_LAST_SYNC_PRODUCTS');
		$dateSync = date("Y-m-d H:i:s", strtotime($dateSync)-60);
		/*if($all)
			$dateSync = 0;*/

        // Se l'oggetto 4dem non è pronto esco
		if (! $this->api4marketingObject->getStatus ()) {

			return false;
		}

		$group_id = Configuration::get("4DEM_PRODUCT_SYNC_GROUP",0);
		if (Configuration::get ( '4DEM_STORE_ID' )) {

			$sql ='
			SELECT PROD.*, IFNULL(pa.id_product_attribute, 0) AS `id_product_attribute`, IFNULL(stock.quantity,0) AS `quantity`
			FROM (SELECT p.id_product, ps.id_category_default, p.date_add,
                (SELECT GROUP_CONCAT(cl.name SEPARATOR "|")
                           FROM `'._DB_PREFIX_.'category` c
                           INNER JOIN '._DB_PREFIX_.'category_shop category_shop ON (category_shop.id_category = c.id_category AND category_shop.id_shop = 1)
                           LEFT JOIN `'._DB_PREFIX_.'category_lang` cl ON (c.`id_category` = cl.`id_category` AND cl.id_lang = '.Context::getContext()->language->id.' AND cl.id_shop = 1)
                            RIGHT JOIN `'._DB_PREFIX_.'category` c2 ON (c.`nleft` <= c2.`nleft` AND c.`nright` >= c2.`nright`)
                           WHERE c.id_category > 2 AND c2.`id_category` = ps.id_category_default) `category`,
                IFNULL(m.name, "") AS `manufacturer`,
               pl.name AS "product_name", p.reference,pl.description_short,pl.description,
                IF(i.id_image > 0,CONCAT("'.Tools::getCurrentUrlProtocolPrefix() . Tools::getHttpHost().'/", i.id_image, "-", "home_default/", pl.`link_rewrite`,".jpg"), "") AS "image_url",
            CASE
            WHEN ps.`available_for_order` AND ps.`active` THEN 1
            ELSE 0
            END AS "active"
            FROM '._DB_PREFIX_.'product p
            JOIN '._DB_PREFIX_.'product_shop ps ON (p.id_product = ps.id_product AND ps.id_shop = 1)
            JOIN '._DB_PREFIX_.'product_lang pl ON (pl.id_product = p.id_product AND pl.id_lang = '.Context::getContext()->language->id.' AND pl.id_shop = 1)
            LEFT JOIN '._DB_PREFIX_.'manufacturer m ON (p.id_manufacturer = m.id_manufacturer)
            LEFT JOIN '._DB_PREFIX_.'image i ON (i.id_product = p.id_product  AND i.cover = 1)
            LEFT JOIN `'._DB_PREFIX_.'image_shop` imgs ON (imgs.id_image = i.`id_image` AND imgs.id_shop = 1)
            WHERE p.id_category_default > 2 AND p.date_upd > "'.($all ? 0 : $dateSync).'"
            LIMIT '.$limit.', 500
            ) PROD
			LEFT JOIN '._DB_PREFIX_.'product_attribute pa ON (PROD.id_product = pa.id_product)
			LEFT JOIN '._DB_PREFIX_.'product_attribute_shop pas ON (pa.id_product_attribute = pas.id_product_attribute AND pas.id_shop = 1)
			LEFT JOIN `'._DB_PREFIX_.'stock_available` stock ON (stock.`id_product` = PROD.id_product AND stock.`id_product_attribute` = IFNULL(pas.`id_product_attribute`,0) AND stock.id_shop = 1)
			WHERE `category` <> ""
			ORDER BY `id_product`;';

			/**
			 * **********************************************************************************
			 * ESECUZIONE DEL CODICE CHE
			 * 1 TENTA DI EFFETTUARE L'INSERIMENTO
			 * 2 SE NON VA A BUON FINE (ESISTE GIA') ESEGUE UN UPDATE
			 * **********************************************************************************
			 */

            // Salvo l'ultima query eseguita
            Configuration::updateValue('4DEM_LAST_CMD_PRODUCTS', $sql);

			$err=array();
			$result_data = Db::getInstance()->executeS($sql);
			if($group_id == 0) {
				$group_id = strtotime(date("Y-m-d H:i:s"));
				Configuration::updateValue("4DEM_PRODUCT_SYNC_GROUP", $group_id);
			}

			if ($result_data) {
				$operations = array();
				foreach($result_data as $key => $product){
					$prodotto = new Product($product["id_product"]);
					$dem_attr = json_decode(Configuration::get("4DEM_ATTRIBUTES_MAP"),true);
					$attributes = array();
					if(count($dem_attr["features"])>0 && count($prodotto->getFeatures())>0) {
						foreach($prodotto->getFrontFeatures(Context::getContext()->cookie->id_lang) as $prod_feat){
							if(isset($dem_attr["features"][$prod_feat["id_feature"]])){
								$tmp["id"] = $dem_attr["features"][$prod_feat["id_feature"]]["id_4dem"];
								$tmp["value"] = $prod_feat["value"];
								$attributes[]=$tmp;
							}
						}
					}
					if(count($dem_attr["attributes"])>0) {
						foreach($dem_attr["attributes"] as $key2 => $attr){

							$sql = "SELECT al.`name`
								FROM `"._DB_PREFIX_."product` as p
								JOIN `"._DB_PREFIX_."product_attribute` as pa ON pa.`id_product` = p.`id_product`
								JOIN `"._DB_PREFIX_."product_attribute_combination` as pac ON pa.`id_product_attribute` = pac.`id_product_attribute`
								JOIN `"._DB_PREFIX_."attribute` as a ON a.`id_attribute` = pac.`id_attribute`
								JOIN `"._DB_PREFIX_."attribute_lang` as al ON al.`id_attribute` = a.`id_attribute`
								WHERE al.`id_lang` = ".Context::getContext()->cookie->id_lang."
								AND p.`id_product` = ".$product["id_product"]."
								AND pac.`id_product_attribute` = ".$product["id_product_attribute"]."
								AND a.`id_attribute_group` = ".$key2;
							$result=Db::getInstance ()->getValue( $sql );
							if($result!="") {
								$tmp["id"] = $attr["id_4dem"];
								$tmp["value"] = $result;
								$attributes[]=$tmp;
							}

						}
					}
					if(!Configuration::get('4DEM_LAST_SYNC_PRODUCTS') || $dateSync==0 || ($dateSync!=0 && strtotime($product["date_add"])>strtotime($dateSync)))
						$op["command"] = "Stores.Product.Store";
					else {
						$op["command"] = "Stores.Product.Update";
						$body["create_if_not_exist"] = true;
					}
					$categories = explode("|",$product["category"]);
					$op["custom_id"] = $key;
					$body["product_id"]=$product["id_product"];
					$body["store_id"] = Configuration::get("4DEM_STORE_ID");
					$body["variant_id"]=$product["id_product_attribute"];
					$body["title"]=$product["product_name"];
					$body["description"]= $product["description_short"] != "" ? utf8_encode(substr(strip_tags($product["description_short"]),0,220)) : utf8_encode(substr(strip_tags($product["description"]),0,220));

					if(count($categories)>0)
						$body["category"]=$categories[count($categories)-1];
					else
						$body["category"]=$product["category"];
					if(count($categories)>1)
						$body["category_med"]=$categories[count($categories)-2];
					if(count($categories)>1)
						$body["category_upper"]=$categories[0];
					$body["status"]=($product["active"] == 1 ? "enabled" : "disabled");
					$body["product_url"]=Context::getContext()->link->getProductLink(new Product($product["id_product"]));
					$body["product_image_url"]=$product["image_url"];
					$body["brand"]=$product["manufacturer"];
					$body["price"]=Product::getPriceStatic($product["id_product"]);
					$body["code"]=$product["reference"];
					$body["attributes"]=$attributes;
					$op["body"] = $body;
					$operations[] = $op;

					//file_put_contents(dirname(__FILE__).'/json_'.$limit.'.log',  json_encode($key), FILE_APPEND | LOCK_EX);

				}
				$ret =  $this->api4marketingObject->massiveImport(Tools::getCurrentUrlProtocolPrefix().Tools::getHttpHost().$this->_path."/s2s/callback_product.php",$operations);
				if(is_numeric($ret)){
					$sql = "INSERT INTO "._DB_PREFIX_."4dem_last_sync (`type`,`date`,`id_batch`,`completed`,`error`,`group`,`tot`) VALUES ('products','".date("Y-m-d H:i:s")."',$ret,0,0,$group_id,".($key+1).")";
					Db::getInstance ()->execute ( $sql );
					$sql = "SELECT sum(tot) FROM "._DB_PREFIX_."4dem_last_sync WHERE `group` = $group_id GROUP BY `group`";
					$sent = Db::getInstance()->getValue($sql);
					$limit+=500;
					return (array("group_id"=>$group_id,"status"=>"waiting","limit"=>$limit,"sent"=>$sent,"done" => 0, "tot" => 0));
				}else {
					$err = ($ret);
					return (array("err" => $err, "status" => "error", "limit" => $limit,"done" => 0, "tot" => 0));
				}
			}
			if(count($err) == 0 ){
				Configuration::updateValue( '4DEM_LAST_SYNC_PRODUCTS',date("Y-m-d H:i:s"));
				return (array("group_id"=>$group_id,"status"=>"complete","limit"=>$limit,"done" => 0, "tot" => 0));
			}else{
				return $err;
			}
		}
	}

    /**
     * Sincronizzazione carrelli
     *
     * @param bool $all
     * @param $type
     * @param $limit
     * @return array|bool
     */
	public function SynchCarts($all = false,$type,$limit) {
		if (! $this->api4marketingObject->getStatus ()) {
			return false;
		}

		$dateSync = Configuration::get('4DEM_LAST_SYNC_CARTS');
		$dateSync = date("Y-m-d H:i:s", strtotime($dateSync)-60);
		/*if($all)
			$dateSync = 0;*/


		$group_id = Configuration::get("4DEM_CART_SYNC_GROUP") ? Configuration::get("4DEM_CART_SYNC_GROUP") : 0;
		if (Configuration::get ( '4DEM_STORE_ID' )) {

	        $states = "";
			if(Configuration::get('4DEM_ORDER_STATES') != "")
	        	$states = implode(",",json_decode(Configuration::get('4DEM_ORDER_STATES'),true));
			$sql ='CREATE TEMPORARY TABLE BridgeCarts
			      SELECT cust.`id_customer`,  b.`id4dem`,cart.`4dem_source`,o.`current_state`,cart.`4dem_source_id`,cart.`date_upd`,cart.`date_add`, cart.`id_cart` AS "id_cart", IF (o.`id_cart` IS NULL OR o.`current_state` NOT IN ('.($states != "" ? $states : 0).'), "open","close") AS `status`
			      FROM '._DB_PREFIX_.'cart cart
			      JOIN `'._DB_PREFIX_.'customer` cust ON (cust.`id_customer` = cart.`id_customer`)
			      RIGHT JOIN '._DB_PREFIX_.'4dem_bridge b ON (b.`id_user` = cust.`id_customer`)
			      LEFT JOIN '._DB_PREFIX_.'orders o ON (o.`id_cart` = cart.`id_cart`)
			      WHERE (cart.date_upd > "'.($all ? date("Y-m-d",strtotime("-200 days",strtotime(date("Y-m-d")))) : $dateSync).'")
			       AND b.`id4dem` IS NOT NULL
			      ORDER BY cust.`id_customer`;';
			if(!Db::getInstance()->execute($sql))
				return false;

			$sql ='ALTER TABLE BridgeCarts ADD INDEX CustomerID(`id_customer`), ADD INDEX CartID(`id_cart`);';
			if(!Db::getInstance()->execute($sql))
				return false;

			$sql ='SELECT c.`id_customer` AS `shop_user_id`,c.`current_state`, c.`4dem_source`,c.`4dem_source_id`,c.date_add,  c.date_upd, c.`id4dem` AS `id_subscriber`, c.`id_cart`, c.`status`,
					GROUP_CONCAT(CONCAT(cp.`id_product`,"-",cp.`id_product_attribute`,"-",cp.`quantity`) SEPARATOR "|") AS `products`
					FROM BridgeCarts c
					JOIN `'._DB_PREFIX_.'cart_product` cp ON (c.`id_cart` = cp.`id_cart`)
					GROUP BY c.`id_cart`
					ORDER BY c.id_cart
				'.($type=="ajax" ? 'LIMIT '.$limit.', 1000' : "").';';
			//WHERE c.date_upd > "'.$today.' 00:00:00"

            // Salvo l'ultima query eseguita
            Configuration::updateValue('4DEM_LAST_CMD_CART', $sql);

			$result_data = Db::getInstance()->executeS($sql);
			if($group_id == 0) {
				$group_id = strtotime(date("Y-m-d H:i:s"));
				Configuration::updateValue("4DEM_CART_SYNC_GROUP", $group_id);
			}
			$err=array();
			$id_map = $this->getIdMap();

			if ($result_data && count($result_data) > 0) {
				$operations = array();
				$not_counted = 0;
				foreach($result_data as $key => $cart){
					if(isset($id_map[$cart["shop_user_id"]]) && $cart["date_add"] != "0000-00-00 00:00:00" && $cart["date_upd"] != "0000-00-00 00:00:00") {
						$body["subscriber_id"] = $id_map[$cart["shop_user_id"]];
						$body["store_id"] = Configuration::get("4DEM_STORE_ID");
						$body["cart_id"] = $cart["id_cart"];
						$body["shop_user_id"] = $cart["shop_user_id"];
						$body["opened_at"] = $cart["date_add"];
						if ($cart["status"] == "close")
							$body["closed_at"] = $cart["date_upd"];
						if ($cart["4dem_source"] != NULL)
							$body["source"] = $cart["4dem_source"];
						if ($cart["4dem_source_id"] != NULL)
							$body["source_id"] = $cart["4dem_source_id"];
						$body["status"] = $cart["status"];
						$products = explode("|", $cart["products"]);
						$products_arr = array();
						$total = 0;
                        $id_order = Order::getOrderByCartId($cart["id_cart"]);
                        $ordine = false;
                        if($id_order) {
                            $ordine = new OrderCore($id_order);
                            $products = $ordine->getOrderDetailList();
                            foreach ($products as $prod) {
                                $product["line_id"] = $cart["id_cart"] . "-" . $prod["product_id"] . "-" . $prod["product_attribute_id"];
                                $product["product_id"] = $prod["product_id"];
                                $product["variant_id"] = $prod["product_attribute_id"];
                                $product["quantity"] = $prod["product_quantity"];
                                $product["price"] = $prod["total_price_tax_incl"];
                                $products_arr[] = $product;
                            }
                            $total = $ordine->total_paid_tax_incl - $ordine->total_shipping;
                        }else {
                            foreach ($products as $prod) {
                                $prod = explode("-", $prod);
                                $product["line_id"] = $cart["id_cart"] . "-" . $prod[0] . "-" . $prod[1];
                                $product["product_id"] = $prod[0];
                                $product["variant_id"] = $prod[1];
                                $product["quantity"] = $prod[2];
                                if ($ordine) {

                                } else
                                    $product["price"] = Product::getPriceStatic($prod[0], true, $prod[1], 2) * $prod[2];
                                $total += $product["price"];
                                $products_arr[] = $product;
                            }
                            $carrello = new Cart($cart["id_cart"]);
                            $total = $carrello->getOrderTotal(true,Cart::BOTH_WITHOUT_SHIPPING);
                        }
						$body["triggers"]["automation"] = false;
						if(!$all)
							$body["triggers"]["automation"] = true;
						if (count($products) > 0)
							$body["total"] = $total;
						$body["products"] = $products_arr;
						$invalid_states = [];
						
						if (Configuration::get('4DEM_INVALID_ORDER_STATE') != "")
							$invalid_states = json_decode(Configuration::get('4DEM_INVALID_ORDER_STATE'),true);
						if(in_array($cart["current_state"], $invalid_states)){
							$op["command"] = "Stores.Cart.Delete";
						}else {
							if (!Configuration::get('4DEM_LAST_SYNC_CARTS') || $dateSync == 0 || ($dateSync != 0 && strtotime($cart["date_add"]) > strtotime($dateSync))) {
								$op["command"] = "Stores.Cart.Store";
							} else {
								$op["command"] = "Stores.Cart.Update";
								$body["create_if_not_exist"] = true;
							}
						}
						$op["custom_id"] = $key;
						$op["body"] = $body;
						$operations[] = $op;

					}else{
						$not_counted ++;
					}
				}
				$ret =  $this->api4marketingObject->massiveImport(Tools::getCurrentUrlProtocolPrefix().Tools::getHttpHost().$this->_path."/s2s/callback_cart.php",$operations);

				if(is_numeric($ret)){
					$sql = "INSERT INTO "._DB_PREFIX_."4dem_last_sync (`type`,`date`,`id_batch`,`completed`,`error`,`group`,`tot`) VALUES ('carts','".date("Y-m-d H:i:s")."',$ret,0,0,$group_id,".(($key-$not_counted)+1).")";
					Db::getInstance ()->execute ( $sql );
					$sql = "SELECT sum(tot) FROM "._DB_PREFIX_."4dem_last_sync WHERE `group` = $group_id GROUP BY `group`";
					$sent = Db::getInstance()->getValue($sql);
					$limit+=1000;
					return (array("group_id"=>$group_id,"status"=>"waiting","limit"=>$limit,"sent"=>$sent,"done" => 0, "tot" => 0));
				}else {
					$err = ($ret);
					return (array("err" => $err, "status" => "error", "limit" => $limit,"done" => 0, "tot" => 0));
				}
			}
			if(count($err) == 0 ){
				Configuration::updateValue( '4DEM_LAST_SYNC_CARTS',date("Y-m-d H:i:s"));
				return (array("group_id"=>$group_id,"status"=>"complete","limit"=>$limit,"done" => 0, "tot" => 0));
			}else{
				return $err;
			}
		}
	}

    /**
     * Ritorna la mappa degli utenti
     *
     * @return array
     */
	private function getIdMap(){
		$sql = "SELECT id_user,id4dem FROM "._DB_PREFIX_."4dem_bridge";
		$res  = Db::getInstance()->executeS($sql);
		$arr=array();
		foreach($res as $row){
			$arr[$row["id_user"]] = $row["id4dem"];
		}
		return $arr;
	}

    /**
     * Ritorna il numero di prodotti
     *
     * @return int
     */
	private function getProductCount(){
		$sql ='
			SELECT COUNT(*)
			FROM (SELECT p.id_product, ps.id_category_default,
                (SELECT GROUP_CONCAT(cl.name SEPARATOR "|")
                           FROM `'._DB_PREFIX_.'category` c
                           INNER JOIN '._DB_PREFIX_.'category_shop category_shop ON (category_shop.id_category = c.id_category AND category_shop.id_shop = 1)
                           LEFT JOIN `'._DB_PREFIX_.'category_lang` cl ON (c.`id_category` = cl.`id_category` AND cl.id_lang = '.Context::getContext()->language->id.' AND cl.id_shop = 1)
                            RIGHT JOIN `'._DB_PREFIX_.'category` c2 ON (c.`nleft` <= c2.`nleft` AND c.`nright` >= c2.`nright`)
                           WHERE c.id_category > 2 AND c2.`id_category` = ps.id_category_default) `category`,
                IFNULL(m.name, "") AS `manufacturer`,
               pl.name AS "product_name", p.reference,pl.description_short,pl.description,
                IF(i.id_image > 0,CONCAT("'.Tools::getCurrentUrlProtocolPrefix() . Tools::getHttpHost().'/", i.id_image, "-", "home_default/", pl.`link_rewrite`,".jpg"), "") AS "image_url",
            CASE
            WHEN ps.`available_for_order` AND ps.`active` THEN 1
            ELSE 0
            END AS "active"
            FROM '._DB_PREFIX_.'product p
            JOIN '._DB_PREFIX_.'product_shop ps ON (p.id_product = ps.id_product AND ps.id_shop = 1)
            JOIN '._DB_PREFIX_.'product_lang pl ON (pl.id_product = p.id_product AND pl.id_lang = '.Context::getContext()->language->id.' AND pl.id_shop = 1)
            LEFT JOIN '._DB_PREFIX_.'manufacturer m ON (p.id_manufacturer = m.id_manufacturer)
            LEFT JOIN '._DB_PREFIX_.'image i ON (i.id_product = p.id_product AND i.cover = 1)
            LEFT JOIN `'._DB_PREFIX_.'image_shop` imgs ON (imgs.id_image = i.`id_image` AND imgs.id_shop = 1)
            WHERE p.id_category_default > 2
            ) PROD
			LEFT JOIN '._DB_PREFIX_.'product_attribute pa ON (PROD.id_product = pa.id_product)
			LEFT JOIN '._DB_PREFIX_.'product_attribute_shop pas ON (pa.id_product_attribute = pas.id_product_attribute AND pas.id_shop = 1)
			LEFT JOIN `'._DB_PREFIX_.'stock_available` stock ON (stock.`id_product` = PROD.id_product AND stock.`id_product_attribute` = IFNULL(pas.`id_product_attribute`,0) AND stock.id_shop = 1)
			WHERE `category` <> "";';

		$res = Db::getInstance()->getValue($sql);

		if ($res == false) {
		    $res = 0;
        }
		return $res;

	}

    /**
     * Ritorna il numero di carrelli
     *
     * @return bool|int
     */
	private function getCartsCount(){
		$invStates = 0;
		if(Configuration::get('4DEM_INVALID_ORDER_STATE') != "")
        	$invStates = implode(",",json_decode(Configuration::get('4DEM_INVALID_ORDER_STATE'),true));
        $states = "";
		if(Configuration::get('4DEM_ORDER_STATES') != "")
        	$states = implode(",",json_decode(Configuration::get('4DEM_ORDER_STATES'),true));

		$sql ='CREATE TEMPORARY TABLE BridgeCarts
					SELECT cust.`id_customer`,  b.`id4dem`, cart.`id_cart` AS "id_cart", IF (o.`id_cart` IS NULL '.($states != "" ? 'OR o.`current_state` NOT IN ('.implode(",",json_decode($states,true)).')' : "") . ', "open","close")  AS `status`
					FROM '._DB_PREFIX_.'cart cart
					JOIN `'._DB_PREFIX_.'customer` cust ON (cust.`id_customer` = cart.`id_customer`)
					RIGHT JOIN '._DB_PREFIX_.'4dem_bridge b ON (b.`id_user` = cust.`id_customer`)
					LEFT JOIN '._DB_PREFIX_.'orders o ON (o.`id_cart` = cart.`id_cart`)
					WHERE (cart.date_upd > "'.date("Y-m-d",strtotime("-6 month")).'")
					 AND b.`id4dem` IS NOT NULL
					 AND o.`current_state` NOT IN ("'.($invStates != "" ? $invStates : 0).'")
					ORDER BY cust.`id_customer`;';
		if(!Db::getInstance()->execute($sql))
			return false;

		$sql ='ALTER TABLE BridgeCarts ADD INDEX CustomerID(`id_customer`), ADD INDEX CartID(`id_cart`);';
		if(!Db::getInstance()->execute($sql))
			return false;
		$sql ='
			SELECT count(*) FROM (
			SELECT c.* FROM BridgeCarts c
			JOIN `'._DB_PREFIX_.'cart_product` cp ON (c.`id_cart` = cp.id_cart)
			GROUP BY c.id_cart
			) AS x';

		$res = Db::getInstance()->getValue($sql);

		if ($res == false) {
		    $res = 0;
        }

		return $res;
	}

    /**
     * Ritorna il numero di contatti
     *
     * @param bool $all
     * @return int
     */
	private function getContactsCount($all = false){
		$dateSync = Configuration::get('4DEM_LAST_SYNC_CONTACTS');
		$dateSync = date("Y-m-d H:i:s", strtotime($dateSync)-60);
		if($all)
			$dateSync = 0;

		$sql ='SELECT count(*) FROM (SELECT * FROM (
			SELECT  customersData.date_upd as upd_cust,'._DB_PREFIX_.'address.date_upd as upd_address,
			customersData.id_customer,
			GROUP_CONCAT(DISTINCT '._DB_PREFIX_.'customer_group.id_group) as gruppi,
			'._DB_PREFIX_.'lang.iso_code AS lingua,
			'._DB_PREFIX_.'state.iso_code AS provincia,
			'._DB_PREFIX_.'address.city,
			'._DB_PREFIX_.'country_lang.name AS paese,
			customersData.is_guest, IF (customersData.id_gender = 1 , "M" , IF (customersData.id_gender = 2 ,
 "F" , "NS")) AS gender ,
			customersData.firstname,
			customersData.lastname,
			customersData.email,
			( SELECT c.date_add FROM '._DB_PREFIX_.'guest g LEFT JOIN '._DB_PREFIX_.'connections c ON c.id_guest = g.id_guest WHERE g
.id_customer = customersData.id_customer ORDER BY c.date_add DESC LIMIT 1 ) as ultima_connessione ,

			customersData.newsletter_date_add,
			'._DB_PREFIX_.'address.phone_mobile,
			customersData.birthday,
			customersData.date_add AS registrazione,
			customersOrders.lastOrderPlaced
		FROM '._DB_PREFIX_.'customer customersData
			LEFT JOIN '._DB_PREFIX_.'lang ON customersData.id_lang = '._DB_PREFIX_.'lang.id_lang
			LEFT JOIN '._DB_PREFIX_.'address ON customersData.id_customer = '._DB_PREFIX_.'address.id_customer
			LEFT JOIN '._DB_PREFIX_.'country_lang ON '._DB_PREFIX_.'address.id_country = '._DB_PREFIX_.'country_lang.id_country AND customersData
.id_lang = '._DB_PREFIX_.'country_lang.id_lang
			LEFT JOIN '._DB_PREFIX_.'state ON '._DB_PREFIX_.'address.id_state = '._DB_PREFIX_.'state.id_state
			LEFT JOIN '._DB_PREFIX_.'customer_group ON '._DB_PREFIX_.'customer_group.id_customer = customersData.id_customer
			LEFT JOIN (
			SELECT id_customer, date(MAX(date_add)) AS lastOrderPlaced
				FROM '._DB_PREFIX_.'orders
			GROUP BY id_customer ) customersOrders ON customersData.id_customer = customersOrders.id_customer


		WHERE customersData.newsletter = 1
				AND customersData.active = 1
				AND customersData.deleted = 0

		GROUP BY customersData.id_customer
		) AS tab  WHERE upd_cust > "'.$dateSync.'" OR ultima_connessione > "'.$dateSync.'" OR lastOrderPlaced
 > "'.$dateSync.'" OR upd_address > "'.$dateSync.'"
		ORDER BY id_customer ) as x';

		$res = Db::getInstance()->getValue($sql);

		if ($res == false) {
		    $res = 0;
        }

		return $res;

	}

    /**
     * Costruisce il blocco di info del contatto per le API 4Dem
     *
     * @param $email
     * @param string $mobile
     * @param bool $customFields
     * @param bool $customerInfo
     * @return array
     */
	private function generateCustomerData($email,$mobile = "",$customFields = false, $customerInfo = false, $newsLetter = 0) {


		$subscribe = array();
		$subscribe["update_if_duplicate"] = true;
		$subscribe["email_address"] = $email;
		if($mobile!="" & $mobile!= null)
			$subscribe["mobile"] = urldecode($mobile);

		if ($customFields) {
			$subscribe["custom_fields"] = array();
			foreach ($customFields as $key => $field) {
				$subscribe["custom_fields"][$key]["id"] = $field;
				$subscribe["custom_fields"][$key]["value"] = $customerInfo[$key];
			}
		}
		$subscribe["subscription"]["ip"] = (isset($_SERVER['REMOTE_ADDR'])) ? $_SERVER['REMOTE_ADDR'] : '0.0.0.0';
		$subscribe["subscription"]["status"] = ($newsLetter == 1 ) ? "Subscribed" : "Opt-In Pending";
		$subscribe["subscription"]["date"] = date("Y-m-d H:i:s");
		$subscribe["recipient_id"] = Configuration::get ( '4DEM_SELECTED_LIST_ID' );

		return $subscribe;
	}

    /**
     * Ritorna il numero degli iscritti alla newsletter (non customers)
     *
     * @param $shopId
     * @param $shopGroup
     * @return int
     */
	private function getEmailSubCount($shopId, $shopGroup, $from) {
        $sql ="
			SELECT 
                COUNT(*)
            FROM
                "._DB_PREFIX_."emailsubscription
            WHERE
                id_shop = '$shopId'
            AND id_shop_group = '$shopGroup'
            AND active = 1
            " . (($from != null) ? "AND newsletter_date_add > '$from';" : ";");

        $sql = preg_replace('/(\v|\s)+/', ' ', $sql);
        $res = Db::getInstance()->getValue($sql);

        if (!is_numeric($res)) {
            $res = 0;
        }

        return $res;
    }

    /**
     * @param $shopId
     * @param $shopGroup
     * @param $from
     * @return array|false|mysqli_result|null|PDOStatement|resource
     * @throws PrestaShopDatabaseException
     */
    private function getEmailSubData($shopId, $shopGroup, $from) {

        $sql ="
			SELECT 
                email,
				ip_registration_newsletter,
		  		null firstname ,
  				null lastname , 
	  			null gender , 
		  		null lingua ,
		  		null is_guest , 
			  	null paese , 
				null provincia , 
				null city , 
			  	null registrazione , 
				null birthday , 
		  		newsletter_date_add , 
		  		1 newsletter,
	  		  	null ultima_connessione ,    
	  			null lastOrderPlaced ,    
		  		null gruppi ,    
		  		1 id_customer, 
	  			null phone_mobile,
	  			null source    
            FROM
                "._DB_PREFIX_."emailsubscription
            WHERE
                id_shop = '$shopId'
            AND id_shop_group = '$shopGroup'
            AND active = 1
            " . (($from != null) ? "AND newsletter_date_add > '$from';" : ";");

        $sql = preg_replace('/(\v|\s)+/', ' ', $sql);
        $res = Db::getInstance()->executeS($sql);
        return $res;
    }


    /**
     * Importazione degli utenti in email
     *
     * @throws PrestaShopDatabaseException
     */
    private function importEmailsubscribers () {

        $dateSync = Configuration::get('4DEM_LAST_SYNC_CONTACTS');
        $dateSync = date("Y-m-d H:i:s", strtotime($dateSync)-60);
        $result_data = [];
        $result_emailsubscribers_count = $this->getEmailSubCount (Context::getContext()->shop->id, Context::getContext()->shop->id_shop_group, $dateSync);
        if ($result_emailsubscribers_count > 0) {
            $result_data = $this->getEmailSubData(Context::getContext()->shop->id, Context::getContext()->shop->id_shop_group, $dateSync);
        }
        if (count($result_data)>0) {
            $operations = array();
            foreach ($result_data as $key => $row) {
                // Use custom fields data
                $subscribeFields = array();
                $subscribeValues = array();
                $fields = json_decode(Configuration::get("4DEM_CUSTOM_FIELDS"), true);

                if (!$fields["source"]["ignore"]) {
                    $subscribeFields [] = $fields["source"]["id"];
                    $subscribeValues [] = "prestashop";
                }

                if (!$fields["name"]["ignore"]) {
                    $subscribeFields [] = $fields["name"]["id"];
                    $subscribeValues [] = ($row ['firstname'] != null ? $row ['firstname'] : "-");
                }
                if (!$fields["surname"]["ignore"]) {
                    $subscribeFields [] = $fields["surname"]["id"];
                    $subscribeValues [] = ($row ['lastname'] != null ? $row ['lastname'] : "-");
                }
                if (!$fields["sex"]["ignore"]) {
                    $subscribeFields [] = $fields["sex"]["id"];
                    $subscribeValues [] = ($row ['gender'] != null ? $row ['gender'] : "-");
                }
                if (!$fields["language"]["ignore"]) {
                    $subscribeFields [] = $fields["language"]["id"];
                    $subscribeValues [] = ($row ['lingua'] != null ? $row ['lingua'] : "-");
                }
                if (!$fields["is_guest"]["ignore"]) {
                    $subscribeFields [] = $fields["is_guest"]["id"];
                    $subscribeValues [] = ($row ['is_guest'] != null ? $row ['is_guest'] : "-");
                }
                if (!$fields["country"]["ignore"]) {
                    $subscribeFields [] = $fields["country"]["id"];
                    $subscribeValues [] = ($row ['paese'] != null ? $row ['paese'] : "-");
                }
                if (!$fields["province"]["ignore"]) {
                    $subscribeFields [] = $fields["province"]["id"];
                    $subscribeValues [] = ($row ['provincia'] != null ? $row ['provincia'] : "-");
                }
                if (!$fields["city"]["ignore"]) {
                    $subscribeFields [] = $fields["city"]["id"];
                    $subscribeValues [] = ($row ['city'] != null ? $row ['city'] : "-");
                }
                if (!$fields["cellphone"]["ignore"]) {
                    $mobile = $row ['phone_mobile'];
                    $mobile = str_replace(' ', '', $mobile);
                    $mobile = str_replace('.', '', $mobile);
                    $mobile = str_replace('-', '', $mobile);
                    if (preg_match('/^\+[1-9]{1}[0-9]{3,14}$/', $mobile)==0) {

                        if (strlen($mobile) == 9) {
                            $mobile = "+39" . $mobile;
                        }
                        else if (strlen($mobile) == 10) {
                            $mobile = "+39" . $mobile;
                        }
                        else if (strlen($mobile) == 12) {
                            $mobile = "+" . $mobile;
                        }
                        else if (strlen($mobile) == 14) {
                            $mobile = preg_replace('^(00)39[0-9]*$', '+', $mobile);
                        } else {
                            $mobile = "";
                        }

                        if (preg_match('/^\+393[0-9]{8,9}$/', $mobile)==0) {  //is italian ?
                            $mobile = "";
                        }
                    }

                    $mobile = urlencode($mobile);
                }
                if (!$fields["reg_date"]["ignore"]) {
                    $subscribeFields [] = $fields["reg_date"]["id"];
                    $subscribeValues [] = ($row ['registrazione'] != null ? $row ['registrazione'] : "0000-00-00");
                }
                if (!$fields["birth_date"]["ignore"]) {
                    $subscribeFields [] = $fields["birth_date"]["id"];
                    $subscribeValues [] = ($row ['birthday'] != null ? $row ['birthday'] : "0000-00-00");
                }
                if (!$fields["news_date"]["ignore"]) {
                    $subscribeFields [] = $fields["news_date"]["id"];
                    $subscribeValues [] = ($row ['newsletter_date_add'] != null ? $row ['newsletter_date_add'] : "0000-00-00");
                }
                if (!$fields["last_conn"]["ignore"]) {
                    $subscribeFields [] = $fields["last_conn"]["id"];
                    $subscribeValues [] = ($row ['ultima_connessione'] != null ? $row ['ultima_connessione'] : "0000-00-00");
                }
                if (!$fields["last_order"]["ignore"]) {
                    $subscribeFields [] = $fields["last_order"]["id"];
                    $subscribeValues [] = ($row ['lastOrderPlaced'] != null ? $row ['lastOrderPlaced'] : "0000-00-00");
                }

                if (!$fields["group"]["ignore"]) {
                    $gruppi = explode(",", $row["gruppi"]);
                    $subscribeFields [] = $fields["group"]["id"];
                    $val = "";
                    foreach ($gruppi as $gruppo) {
                        $val .= $gruppo . "||||";
                    }
                    $subscribeValues [] = rtrim($val, "||||");

                }

                $command["command"] = "Subscriber.Store";
                $command["custom_id"] = $row["id_customer"];
                $command["body"] = $this->generateCustomerData($row ['email'], $mobile, $subscribeFields, $subscribeValues, $row['newsletter']);
                $operations[] = $command;
            }

            $res = $this->api4marketingObject->massiveImport(Tools::getCurrentUrlProtocolPrefix() . Tools::getHttpHost() . null, $operations);
            Configuration::updateValue('4DEM_LAST_EMAILSUBSCRIBERS_CMD', json_encode($res));
            return;
        }
}
}
